package com.ajja.service.bootstrap.common.impl.quarkus.sql;

import com.ajja.service.bootstrap.common.application.sql.IPreparedStatement;
import com.ajja.service.bootstrap.common.application.sql.ISQLConnection;
import com.ajja.service.bootstrap.common.application.sql.exception.SQLException;
import com.mysql.cj.jdbc.exceptions.CommunicationsException;
import io.agroal.api.AgroalDataSource;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.sql.Connection;

@Singleton
public class SQLConnectionImpl implements ISQLConnection {

    @Inject
    AgroalDataSource agroalDataSource;

    @Override
    public IPreparedStatement prepareStatement(String sql) throws SQLException {
        try {
            final Connection connection = agroalDataSource.getConnection();
            return new PreparedStatementImpl(connection, sql);
        } catch (CommunicationsException e) {
            throw new RuntimeException(e);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public IPreparedStatement prepareStatement(String sql, int autoGeneratedKeys) throws SQLException {
        try {
            final Connection connection = agroalDataSource.getConnection();
            return new PreparedStatementImpl(connection, sql, autoGeneratedKeys);
        } catch (CommunicationsException e) {
            throw new RuntimeException(e);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }
}
